{
   This is the reference solution to problem A ('Gra planszowa')

   Author : Bartosz Nowierski
}

{$R+,S+}
program A_GraPlanszowa;

const MAXN = 100;
      MAXG = 10;

var board: string;
    N, i: longint;
    boards, b: longint;
    games, g: longint;
    gen, size, count: array [0..MAXN] of longint;
    f1, f2, f: longint;
    ch: char;


procedure assert(expr: boolean; str: string);
begin
  if not expr then
  begin
    writeln('ASSERTION FAILED: ', str);
    halt(1);
  end;
end;
    

function boardchar(f: longint; deg: longint): char;
begin
  if deg = 0 then
  begin
    boardchar := board[f+1];
    Exit;
  end;
  boardchar := boardchar(f mod (size[deg-1]), deg-1);
end;


function countchars(f1, f2: longint; deg: longint): longint;
var cnt: longint;
    nf1, nf2: longint;

begin
//writeln('>>>  ', f1, ' ', f2, '   ', deg, ' ');
  if f1 = f2 then
  begin
    countchars := 0;
//writeln('<<<  0');
    exit;
  end;
  if deg = 0 then
  begin
    cnt := 0;
    for nf1 := f1 to f2-1 do
    begin
      if board[nf1+1] = ch then
      begin
        inc(cnt);
      end;
    end;
    countchars := cnt;
//writeln('<<<  ', cnt);
    exit;
  end;

  cnt := ((f2 div size[deg-1])-(f1 div size[deg-1]))*count[deg-1];
//writeln('cnt=',cnt, '  count[deg-1]=',count[deg-1]);
  nf1 := f1 mod size[deg-1];
  nf2 := f2 mod size[deg-1];
  if nf2 < nf1 then
  begin
    dec(cnt, countchars(nf2, nf1, deg-1));
    countchars := cnt;
//writeln('<<<  ', cnt);
  end else
  begin
    inc(cnt, countchars(nf1, nf2, deg-1));
    countchars := cnt;
//writeln('<<<  ', cnt);
  end;
end;


begin
  readln(boards);
  for b := 1 to boards do
  begin
    writeln('PLANSZA ', b);
    readln(board);
assert((length(board)>0)and(length(board)<=255), 'board length');
    size[0] := length(board);
    readln(N);
assert((N>=1)and(N<=MAXN), 'N value');
    for i := 1 to N do
    begin
      read(gen[i]);
      size[i] := gen[i]*size[i-1];
assert((size[i]>=size[i-1])and(size[i]<=2100000000)and(size[i]>=2), 'higher degree board length');
    end;
    readln;
    
    readln(games);
assert((games>=1)and(games<=MAXG), 'number of games');
    for g := 1 to games do
    begin
      readln(f1, f2);
assert((f1>=1)and(f1<=size[N])and(f2>=1)and(f2<=size[N]), 'field range');
      if f1 > f2 then
      begin
        f := f1;
        f1 := f2;
        f2 := f;
      end;
      dec(f1);
      dec(f2);
      
      ch := boardchar(f1,N);
assert(ch = boardchar(f2,N), 'field content');
     
      count[0] := 0;
      for i := 1 to size[0] do
      begin
        if board[i] = ch then
        begin
          inc(count[0]);
        end;
      end;
      for i := 1 to N do
      begin
        count[i] := count[i-1]*gen[i];
      end;

      write('GRA ', g, ': ');
      if countchars(f1, f2, N) mod 2 = 1 then
      begin
        writeln('TAK');
      end else
      begin
        writeln('NIE');
      end;
    end;
    writeln;
  end;
end.

