/*
   This is the reference solution to problem B ('Fabryki')

   Author : Michal Rein
*/
#include <iostream>
   using namespace std;
#include <stdio.h>

const int MAX_OBJECTS = 100;
const int PLUS_INFINITY = 99999;

typedef struct object_s {
   int info;         // zalezne od typu obiektu
   bool isFactory;   // jezeli nie fabryka, to miasto
} object_t;


int hash[100000];
int objectN;
object_t object[MAX_OBJECTS];

int graph[MAX_OBJECTS][MAX_OBJECTS];

int main() {
   int Q, i, j, k, temp1, temp2, temp3, tempN, result;
   cin>>Q;
   for (int q=0; q<Q; q++) {
      objectN = 0;
      // wczytuje informacje o fabrykach
      cin>>tempN;
      for (i=0; i<tempN; i++) {
         cin>>temp1>>temp2;
         hash[temp1] = objectN;
         object[objectN].info = temp2;
         object[objectN].isFactory = true;
         objectN++;
      }
      // wczytuje informacje o miastach
      cin>>tempN;
      for (i=0; i<tempN; i++) {
         cin>>temp1>>temp2;
         hash[temp1] = objectN;
         object[objectN].info = temp2;
         object[objectN].isFactory = false;
         objectN++;
      }
      // zeruje graf polaczen
      for (i=0; i<objectN; i++)
         for (j=0; j<objectN; j++)
            graph[i][j] = PLUS_INFINITY;
      // wczytuje informacje o kosztach polaczen
      cin>>tempN;
      for (i=0; i<tempN; i++) {
         cin>>temp1>>temp2>>temp3;
         graph[ hash[temp1] ][ hash[temp2] ] = temp3;
         graph[ hash[temp2] ][ hash[temp1] ] = temp3;
      }
      // zmodyfikowany algorytm Floyd'a - Warshall'a (chyba) obliczania
      // minimalnej odleglosci miedzy wszystkimi wierzcholkami
      // !! ta implementacja jest dla grafu skierowanego, zeby latwiej bylo gorny limt czasowy ustawic !!
      for (i=0; i<objectN; i++)
         for (j=0; j<objectN; j++)
            for (k=0; k<objectN; k++)
               if ( graph[i][j] > graph[i][k] + graph[k][j] )
                  graph[i][j] = graph[i][k] + graph[k][j];
      // obliczam wynik
      result = 0;
      int minVal, minIdx;
      for (i=0; i<objectN; i++)
         if ( object[i].isFactory ) {
            minVal = PLUS_INFINITY;
            for (j=0; j<objectN; j++)
               if ( !object[j].isFactory && minVal > graph[i][j] + object[j].info ) {
                  minVal = graph[i][j] + object[j].info;
                  minIdx = j;
               }
            result += object[i].info * minVal;
         }
      cout<<result<<endl;
   }
   return 0;
}
