{
   This is the reference solution to problem C ('Szkoly')

   Author : Bartosz Nowierski
}

const MAXN = 500;
var G: array [1..MAXN, 1..MAXN] of boolean;
    D: array [1..MAXN] of integer;
    N, M: longint;
    i, j: longint;
    v1, v2: integer;
    possible: boolean;
    sets, s: integer;


procedure assert(expr: boolean; str: string);
begin
  if not expr then
  begin
    writeln('ASSERTION FAILED: ', str);
    halt(1);
  end;
end;


function BFS(start: integer): boolean;
var list: array [1..MAXN] of integer;
    lb, le: integer;
    v: integer;
    i: integer;

begin
  D[start] := 0;
  list[1] := start;
  lb := 1;
  le := 1;
  while lb <= le do
  begin
    v := list[lb];
    inc(lb);
    for i := 1 to N do
    begin
      if G[v,i] then
      begin
        if (D[i] >= 0) and ((D[v]+1-D[i]) mod 2 <> 0) then
        begin
          BFS := FALSE;
          exit;
        end;
        if D[i] < 0 then
        begin
          D[i] := D[v]+1;
          inc(le);
          list[le] := i;
        end;
      end;
    end;
  end;
  
  BFS := TRUE;
end;


begin
  read(sets);
  assert(sets > 0, 'invalid number of sets');
  
  for s := 1 to sets do
  begin
    read(N,M);
    assert((N >= 2) and (N <= MAXN), 'bad N');
    assert((M >= 0) and (M <= (N*(N-1)) div 2), 'bad M');
    for i := 1 to N do
    begin
      for j := 1 to N do
      begin
        G[i,j] := FALSE;
      end;
    end;

    for i := 1 to M do
    begin
      read(v1, v2);
      assert((not G[v1,v2]) and (not G[v2,v1]), 'edge already exists');
      G[v1,v2] := TRUE;
      G[v2,v1] := TRUE;
    end;

    for i := 1 to N do
    begin
      D[i] := -1;
    end;

    possible := TRUE;
    for i := 1 to N do
    begin
      if D[i] < 0 then
      begin
        if not BFS(i) then
        begin
          possible := FALSE;
          break;
        end;
      end;
    end;

    if not possible then
    begin
      writeln('NIE');
    end else
    begin
      for i := 1 to N do
      begin
        if D[i] mod 2 = 0 then
        begin
          write(i, ' ');
        end;
      end;
      writeln(-1);
    end;
    
  end;
end.

