/*
   This is the reference solution to problem F ('Sortowanie')

   Author : Bartosz Nowierski
*/
#undef NDEBUG

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#define MAXC 32
#define MAXN 10000
#define MAXS (MAXC*4+1)


int N, C;
unsigned char symb[MAXN][MAXC];
int sort[MAXN];
int count[256];
int *queue[256];


int temp1, temp2;
int compare(const void* ref1, const void* ref2) {
   return strncmp( (char*)symb[*((int*)ref1)], (char*)symb[*((int*)ref2)], C);
}


int main()
{
  int d, i, j, k;
  int len, pos;
  char str[MAXS];
  int v1, v2;
  unsigned char ch;


  assert(scanf("%d", &d) == 1);
  while (d--)
  {
    assert(scanf("%d%d", &N, &C) == 2);
    assert(N >= 1 && N <= MAXN);
    assert(C >= 1 && C <= MAXC);
    for (i = 0; i < N; ++i)
    {
      assert(scanf("%s", str) == 1);
      len = strlen(str);
      pos = 0;
      assert(len >= 1 && len <= 4*MAXC);
      j = 0;
      while (j < len)
      {
        assert(pos < C);
        if (str[j] == '\\')
        {
          assert(j+3 < len);
          assert(str[j+1] == 'x');
          assert((str[j+2] >= '0' && str[j+2] <= '9') ||
            (str[j+2] >= 'A' && str[j+2] <= 'F'));
          assert((str[j+3] >= '0' && str[j+3] <= '9') ||
            (str[j+3] >= 'A' && str[j+3] <= 'F'));
          if (str[j+2] < 'A')
            v1 = str[j+2]-'0';
          else
            v1 = str[j+2]-'A'+10;
          if (str[j+3] < 'A')
            v2 = str[j+3]-'0';
          else
            v2 = str[j+3]-'A'+10;
          ch = (unsigned char)(v1*16+v2);
          assert(!((ch >= 'a' && ch <= 'z') ||
            (ch >= 'A' && ch <= 'Z') || (ch >= '0' && ch <= '9')));
          assert(ch != 0);
          symb[i][pos] = ch;
          j += 4;
        }
        else
        {
          ch = str[j];
          assert((ch >= 'a' && ch <= 'z') ||
            (ch >= 'A' && ch <= 'Z') || (ch >= '0' && ch <= '9'));
          symb[i][pos] = ch;
          ++j;
        }
        ++pos;
      }

      sort[i] = i;
    }

    qsort(sort, N, sizeof(int), &compare);
/*    for (j = C-1; j >= 0; --j)
    {
      for (k = 0; k < 256; ++k)
      {
        count[k] = 0;
      }
      for (i = 0; i < N; ++i)
      {
        ++count[(int)symb[i][j]];
      }
      for (k = 0; k < 256; ++k)
      {
        queue[k] = malloc(count[k]*sizeof(int));
        assert(queue[k] != NULL);
        count[k] = 0;
      }
      for (i = 0; i < N; ++i)
      {
        k = (int)symb[sort[i]][j];
        queue[k][count[k]++] = sort[i];
      }
      pos = 0;
      for (k = 0; k < 256; ++k)
      {
        for (i = 0; i < count[k]; ++i)
        {
          sort[pos++] = queue[k][i];
        }
        free(queue[k]);
      }
    }
*/    for (i = 0; i < N; ++i)
    {
      for (j = 0; j < C; ++j)
      {
//        assert(i == 0 || strncmp((char*)symb[sort[i]], (char*)symb[sort[i-1]], C) != 0);

        ch = symb[sort[i]][j];
        if ((ch >= 'a' && ch <= 'z') ||
          (ch >= 'A' && ch <= 'Z') || (ch >= '0' && ch <= '9'))
        {
          printf("%c", ch);
        }
        else
        {
          printf("\\x%02X", ch);
        }
      }
      printf("\n");

//      printf("%d\n", sort[i]+1);
    }
  }

  return 0;
}
