/*
   This is the reference solution to problem G ('Saperzy')

   Author : Pawel Gruszczynski
*/

#include<stdio.h>

const int MAX_SIZE = 10;

int board[MAX_SIZE][MAX_SIZE];
int checked[MAX_SIZE][MAX_SIZE];
int boardSize;

class cords {
    public :
    int x;
    int y;
};

cords queue[MAX_SIZE * MAX_SIZE];
int qSize = 0;

cords start;
cords end;

void process(cords p, int dx, int dy)
{
    int newX = p.x + dx;
    int newY = p.y + dy;
    if (newX < 0 || newX >= boardSize || newY < 0 || newY >= boardSize) {
        return;
    }
    if (checked[newX][newY] || board[newX][newY] == 1) {
    	return;
    }
    queue[qSize].x = newX;
    queue[qSize++].y = newY;
    checked[newX][newY] = 1;
}


void process(cords p)
{
    process(p, -1, 0);
    process(p, 1, 0);
    process(p, 0, -1);
    process(p, 0, 1);
}


int iterate()
{
    int res = 0;
    int i = 0;
    while (!checked[end.x][end.y]) {
        int oldSize = qSize;
        res++;
        if (i == oldSize) {
            return -1;
        }
        while (i < oldSize) {
    	    process(queue[i++]);
        }
    }
    return res;
}


void solve()
{
    scanf("%i", &boardSize);
    for (int i = 0; i < boardSize; i++) {
    	for (int j = 0; j < boardSize; j++) {
            scanf("%i", board[i] + j);
            checked[i][j] = 0;
            if (board[i][j] == 2) {
            	start.x = i;
            	start.y = j;
            	checked[i][j] = 1;
            }
            else if (board[i][j] == 9) {
            	end.x = i;
            	end.y = j;
            }
        }
    }
    queue[0] = start;
    qSize = 1;
    printf("%i\n", iterate());
}


int main()
{
    int num;
    scanf("%i", &num);
    for (int i = 0; i < num; i++) {
    	solve();
    }
    return 0;
}
