/*
   This is the reference solution to problem G ('Saperzy')

   Author : Michal Rein
*/

#include <iostream>
   using namespace std;

const int MAX_SIZE =  10;
const int MAX_LENGTH = 0xFFFFFFF;

int field[MAX_SIZE+2][MAX_SIZE+2];
int minLength[MAX_SIZE+2][MAX_SIZE+2];

int startX, startY, bombX, bombY;

// najmniej efektywna rekurencja, jaka moge wymyslec :)
void go(int x, int y, int depth) {
   // jezeli mina, to nie ide dalej
   if ( field[y][x] == 1 )
      return;
   // sprawdzam, czy juz tu bylem krotsza sciezka
   if ( minLength[y][x] > depth )
      minLength[y][x] = depth;
   else
      return;
   // jezeli bomba, to nie ide dalej
   if ( field[y][x] == 9 )
      return;
   // probuje isc we wszystkie mozliwe strony
   go(x-1, y, depth+1);
   go(x+1, y, depth+1);
   go(x, y-1, depth+1);
   go(x, y+1, depth+1);
}

// program glowny
int main() {
   int Q, N;
   cin>>Q;
   for (int q=0; q<Q; q++) {
      cin>>N;
      int x, y;
      // wypelnianie tablicy 1-kami, zeby miec miny na krawedziach
      for (y=0; y<MAX_SIZE+2; y++)
         for (x=0; x<MAX_SIZE+2; x++) {
            field[y][x] = 1;
            minLength[y][x] = MAX_LENGTH;
      }
      // wczytywanie pola
      for (y=1; y<=N; y++)
         for (x=1; x<=N; x++) {
            cin>>field[y][x];
            // zapamietuje pozycje startu i pozycje bomby
            if ( field[y][x] == 2 ) {
               startX = x;
               startY = y;
            }
            if ( field[y][x] == 9 ) {
               bombX = x;
               bombY = y;
            }
      }
      go(startX, startY, 0);
      cout<<minLength[bombY][bombX]<<endl;
   }
   return 0;
}
